#include <stdio.h>

#include <math.h>
#include <helper_math.h>

#include <gl/freeglut.h>

#include "BasicDef.h"
#include "BBox.h"

// BBox؂̐[D
unsigned int BBox_tree_level;

// \[gɗpϐD
extern float *sort_value;		
extern int *sort_id;

// _D
extern double point[MAX_NUM_POINTS][3];
extern unsigned int num_points;

// Op`|SD
extern unsigned int triangle[MAX_NUM_TRIANGLES][3];
extern unsigned int num_triangles;

// O`̊֐D
extern float4 cross(float4 a, float4 b);
extern float4 mulMV(float4 *a, float4 v);
extern void transM(float4 *a, float4 *a_t);
extern void quickSort(int l, int r);
extern void calcJacobi(float a[3][3], float eigen_vec[3][3], float eigen_value[3]);

// AABBւ̃f[^̃ZbgD
void setAABB(BBox *AABB)
// BBox *AABB; AABBD
{
	unsigned int i, j;
	float val;
	float h_max[3] = {- LARGE, - LARGE, - LARGE};
	float h_min[3] = {LARGE, LARGE, LARGE};
	tmp_triangle *tri;

	// AABB̎i[D
	AABB->axis[0].x = 1.0f; 
	AABB->axis[0].y = 0.0f; 
	AABB->axis[0].z = 0.0f;
	AABB->axis[0].w = 0.0f;
	AABB->axis[1].x = 0.0f;
	AABB->axis[1].y = 1.0f;
	AABB->axis[1].z = 0.0f;
	AABB->axis[1].w = 0.0f;
	AABB->axis[2].x = 0.0f;
	AABB->axis[2].y = 0.0f;
	AABB->axis[2].z = 1.0f;
	AABB->axis[2].w = 0.0f;

	// e_AABB̎xNg̓ς߁C̍őƍŏ𓾂D
	tri = AABB->first;
	while (tri != NULL) {
		for (i = 0; i < 3; i++) {
			for (j = 0; j < 3; j++) {
				val = dot(AABB->axis[j], tri->vertex[i]);
				if (h_min[j] > val)
					h_min[j] = val;
				if (h_max[j] < val)
					h_max[j] = val;
			}
		}
		tri = tri->next;
	}

	// AABB̕ӂ̒i̔jߊi[D
	AABB->h[0] = (h_max[0] - h_min[0]) / 2.0f;
	AABB->h[1] = (h_max[1] - h_min[1]) / 2.0f;
	AABB->h[2] = (h_max[2] - h_min[2]) / 2.0f;

	// AABB̒S_߂D
	AABB->center = ((h_max[0] + h_min[0]) / 2.0f) * AABB->axis[0] + ((h_max[1] + h_min[1]) / 2.0f) * AABB->axis[1] + ((h_max[2] + h_min[2]) / 2.0f) * AABB->axis[2];
	AABB->center.w = 1.0f;
}

// OBBւ̃f[^̃ZbgD{̓|SQ̓ʕpׂCȉł
// |SQ̂܂ܗpĂD
void setOBB(BBox *OBB)
// BBox *OBB; OBBD
{
	unsigned int i, j;
	float val, tri_cen[3], tri_ver[3][3];
	float c_mat[3][3];		// UsD
	float eigen_vec[3][3];  // ŗLlxNgD
	float eigen_value[3];   // ŗLlD
	float weight_cen[3];	// ʐςŏdݕtꂽdS̕ρD
	float sum_area;			// S|S̖ʐϘaD	
	float h_max[3] = {- LARGE, - LARGE, - LARGE};
	float h_min[3] = {LARGE, LARGE, LARGE};
	tmp_triangle *tri;

	// |SQ̏dS̏d݂Âς̎擾D
	sum_area = 0.0f;
	for (i = 0; i < 3; i++)
		weight_cen[i] = 0.0f;
	tri = OBB->first;
	while (tri != NULL) {
		weight_cen[X] += tri->area * tri->center.x;
		weight_cen[Y] += tri->area * tri->center.y;
		weight_cen[Z] += tri->area * tri->center.z;
		sum_area += tri->area;
		tri = tri->next;
	}
	weight_cen[X] /= sum_area; 
	weight_cen[Y] /= sum_area; 
	weight_cen[Z] /= sum_area;

	// UšvZD
	for(i = 0; i < 3; i++)
		for(j = 0; j < 3; j++)
			c_mat[i][j] = 0.0f;
	tri = OBB->first;
	while (tri != NULL) {

		// OBBɑe|S̏dS擾D
		tri_cen[X] = tri->center.x;
		tri_cen[Y] = tri->center.y;
		tri_cen[Z] = tri->center.z;

		// OBBɑe|S3_擾D
		for (i = 0; i < 3; i++) {
			tri_ver[i][X] = tri->vertex[i].x;
			tri_ver[i][Y] = tri->vertex[i].y;
			tri_ver[i][Z] = tri->vertex[i].z;
		}
		for (i = 0; i < 3; i++)
			for (j = 0; j < 3; j++)

				// Us߂D
				c_mat[i][j] += (tri->area / 12.0f) * (9.0f * tri_cen[i] * tri_cen[j] + tri_ver[0][i] * tri_ver[0][j] + tri_ver[1][i] * tri_ver[1][j] + tri_ver[2][i] * tri_ver[2][j]);
		tri = tri->next;
	}
	for(i = 0; i < 3; i++) {
		for(j = 0; j < 3; j++) {
			c_mat[i][j] = (c_mat[i][j] / sum_area) - weight_cen[i] * weight_cen[j];
		}
	}

	// ŗLlƌŗLxNg߂D
	calcJacobi(c_mat, eigen_vec, eigen_value);

	// ŗLlxNgOBB̎ߊi[D
	OBB->axis[0].x = eigen_vec[0][0]; 
	OBB->axis[0].y = eigen_vec[1][0]; 
	OBB->axis[0].z = eigen_vec[2][0];
	OBB->axis[0].w = 0.0f;
	OBB->axis[1].x = eigen_vec[0][1];
	OBB->axis[1].y = eigen_vec[1][1];
	OBB->axis[1].z = eigen_vec[2][1];
	OBB->axis[1].w = 0.0f;
	OBB->axis[2].x = eigen_vec[0][2];
	OBB->axis[2].y = eigen_vec[1][2];
	OBB->axis[2].z = eigen_vec[2][2];
	OBB->axis[2].w = 0.0f;

	// e_OBB̎xNg̓ς߁C̍őƍŏ𓾂D
	tri = OBB->first;
	while (tri != NULL) {
		for (i = 0; i < 3; i++) {
			for (j = 0; j < 3; j++) {
				val = dot(OBB->axis[j], tri->vertex[i]);
				if (h_min[j] > val)
					h_min[j] = val;
				if (h_max[j] < val)
					h_max[j] = val;
			}
		}
		tri = tri->next;
	}

	// OBB̕ӂ̒i̔jߊi[D
	OBB->h[0] = (h_max[0] - h_min[0]) / 2.0f;
	OBB->h[1] = (h_max[1] - h_min[1]) / 2.0f;
	OBB->h[2] = (h_max[2] - h_min[2]) / 2.0f;

	// OBB̒S_߂D
	OBB->center = ((h_max[0] + h_min[0]) / 2.0f) * OBB->axis[0] + ((h_max[1] + h_min[1]) / 2.0f) * OBB->axis[1] + ((h_max[2] + h_min[2]) / 2.0f) * OBB->axis[2];
	OBB->center.w = 1.0f;
}

// BBox̍ċAIȕɂBBox؂̍\D
void divideBBox(unsigned int level, tree_node *node, unsigned int *h_vertex_index, float4 *h_vertex, unsigned int *h_vertex_to_triangle,
	tmp_triangle *triangle, unsigned int *num_leaf_BBoxes)
// unsigned int level; BBox؂݂̌̐[D
// tree_node *node; BBox؂̃m[hD
// unsigned int *h_vertex_index; h_vertex֒_f[^i[ۂ̐擪̃CfbNXD
// float4 *h_vertex; _f[^̔zD
// unsigned int *h_vertex_to_triangle; h_vertextrianglȇΉ֌WD
// tmp_triangle *triangle; Op`|S̔zD
// unsigned int *num_leaf_BBoxes; [BBox̑̃JE^D
{
	unsigned int i, j, sort_index;
	int num_tris0, num_tris1;
	tmp_triangle *first0, *first1, *tri;

	// BBoxւ̃f[^̊i[D
	//setAABB(&(node->BBox));
	setOBB(&(node->BBox));

	// ؂̏I[m[h̏ꍇD
	if ((level == MAX_BBOX_TREE_LEVEL) || (node->BBox.num_tris <= (MAX_NUM_TRIS_IN_BBOX))) {
		if (level > BBox_tree_level)
			BBox_tree_level = level;
	    tri = node->BBox.first;
	    for (i = 0; i < node->BBox.num_tris; i++) {

		    // BBoxɑe|S3_擾D
		    for(j = 0; j < 3; j++) {

			    // BBoxɕ܂Ă|S̒_f[^ۑD
			    h_vertex[*h_vertex_index + 3 * i + j] = tri->vertex[j];
				h_vertex_to_triangle[*h_vertex_index + 3 * i + j] = tri->index;
		    }
		    tri = tri->next;
	    }
 
        // BBoxɑ|Sf[^i_f[^j̐擪L^D
        node->BBox.tri_index = *h_vertex_index;
        (*h_vertex_index) += 3 * node->BBox.num_tris;
 
		// ꂽ[BBox̐̍XVD
 		(*num_leaf_BBoxes)++;
         
		// [ł邱Ƃ𖾎D
		node->node0 = node->node1 = NULL;
	} else {

		// ł̎Ƀ|S̏dSW𓊉eC
		// ŜQ̃O[vɕD
		if (node->BBox.h[0] > node->BBox.h[1])
			if (node->BBox.h[2] > node->BBox.h[0])
				sort_index = 2;
			else
				sort_index = 0;
		else
			if (node->BBox.h[2] > node->BBox.h[1])
				sort_index = 2;
			else
				sort_index = 1;
		tri = node->BBox.first;
		for(i = 0; i < node->BBox.num_tris; i++) {
			sort_value[i] = dot(node->BBox.axis[sort_index], tri->center);
			sort_id[i] = tri->index;
			tri = tri->next;
		}

		// IꂽɂďdS\[gD
		quickSort(0, node->BBox.num_tris - 1);

		// |SQ2̃XgɕD
		for(i = 0; i < node->BBox.num_tris / 2 - 1; i++)
			triangle[sort_id[i]].next = &triangle[sort_id[i + 1]]; 
		triangle[sort_id[node->BBox.num_tris / 2 - 1]].next = NULL;
		for(i = node->BBox.num_tris / 2; i < node->BBox.num_tris - 1; i++)
			triangle[sort_id[i]].next = &triangle[sort_id[i + 1]];
		triangle[sort_id[node->BBox.num_tris - 1]].next = NULL;

		// QBBoxɕ܂|S̐擾D
		num_tris0 = node->BBox.num_tris / 2;
		num_tris1 = node->BBox.num_tris - num_tris0;

		// QBBox̐擪ƂȂ|S̃|C^擾D
		first0 = &triangle[sort_id[0]];
		first1 = &triangle[sort_id[node->BBox.num_tris / 2]];

		// BBox2ɕD
		node->node0 = (tree_node *)malloc(sizeof(tree_node));
		node->node0->BBox.num_tris = num_tris0;
		node->node0->BBox.first = first0;
		divideBBox((level + 1), node->node0, h_vertex_index, h_vertex, h_vertex_to_triangle, triangle, num_leaf_BBoxes);
		node->node1 = (tree_node *)malloc(sizeof(tree_node));
		node->node1->BBox.num_tris = num_tris1;
		node->node1->BBox.first = first1;
		divideBBox((level + 1), node->node1, h_vertex_index, h_vertex, h_vertex_to_triangle, triangle, num_leaf_BBoxes);
	}
}

// Op`|S̖ʐς̌vZƋL^D
void calcTriArea(tmp_triangle *triangle)
// tmp_triangle *triangle; Op`|Sւ̃|C^D
{
	float4 v0, v1, c;

	// |S2ӂɂxNg߂D
	v0 = triangle->vertex[1] - triangle->vertex[0];
	v1 = triangle->vertex[2] - triangle->vertex[0];

	// ̊Oς̒̔ʐρD
	c = cross(v0, v1);
	triangle->area = sqrt(dot(c, c)) / 2.0f;
}

// BBox؂̍\zD
void buildBBoxTree(tree_node *root_node, float4 *h_vertex, unsigned int *h_vertex_to_triangle)
// tree_node *root_node; BBox؂̃[gm[hD
// float4 *h_vertex; _f[^̔zD
// unsigned int *h_vertex_to_triangle; h_vertextrianglȇΉ֌WD
{
    unsigned int i, j;
	unsigned int h_vertex_index, num_leaf_BBoxes;
	float4 tmp_pnt;
	tmp_triangle *tri;

	// Op`|Sp̈ꎞIȃmہD
	tri = (tmp_triangle *)malloc(sizeof(tmp_triangle) * num_triangles);

	// Op`|Sւ̃f[^̊i[D
	for(i = 0; i < num_triangles; i++) {

		// Wf[^i[D
		for(j = 0; j < 3; j++) {
			tmp_pnt.x = (float)point[triangle[i][j]][X];
			tmp_pnt.y = (float)point[triangle[i][j]][Y];
			tmp_pnt.z = (float)point[triangle[i][j]][Z];
			tmp_pnt.w = 1.0f;
			tri[i].vertex[j] = tmp_pnt;
		}

		// dS̊i[D
		tri[i].center = (tri[i].vertex[0] + tri[i].vertex[1] + tri[i].vertex[2]) / 3.0f;

		// ʐς̊i[D
		calcTriArea(&tri[i]);

		// Ƃtriangle̔ԍ܂ĂD
		tri[i].index = i;

		// BBox̃|Sf[^̏Xg쐬DBBox؍\ɔjIɍXVD
		if (i == 0) {
			root_node->BBox.first = &tri[0];
			tri[0].next = &tri[1];
		} else if (i == num_triangles - 1)
			tri[i].next = NULL;
		else
			tri[i].next = &tri[i + 1];
	}
	root_node->BBox.num_tris = num_triangles;

	// BBox؂̍쐬̍ۂɗp\[gp̃̏D
	sort_value = (float *)malloc(num_triangles * sizeof(float));
	sort_id = (int *)malloc(num_triangles * sizeof(int));

	// BBox؂̍쐬Dɒ_f[^h_vertexɊi[D
	h_vertex_index = 0;
	num_leaf_BBoxes = 0;
	BBox_tree_level = 0;
	divideBBox(0, root_node, &h_vertex_index, h_vertex, h_vertex_to_triangle, tri, &num_leaf_BBoxes);

	// ̉D
	free(tri);
	free(sort_value);
	free(sort_id);

	// ꂽ[BBox̕\D
	printf("Leaf BBoxes: %d\n", num_leaf_BBoxes);
}

// BBox؂̃̉D
void freeBBoxTree(tree_node *node)
// tree_node *node; BBox؂̃m[hD
{
	if (node->node0) 
		freeBBoxTree(node->node0);
	if (node->node1) 
		freeBBoxTree(node->node1);
	free(node);
}

// _BBoxԂ̋̍ŏlD
float minDistPointBBox(float4 point, float radius, BBox BBox)
// float4 point; _̍WlD
// float radius; ̔aD
// BBox BBox; ܃{bNXD
{
	int i;
    float h[3], ref, dist, min_dist;
	float4 q_min, d;

	// l̐ݒD
    q_min = BBox.center;
    d = point - q_min;

	// BBox̊eӂɊÂċXVD
    h[0] = BBox.h[0];
    h[1] = BBox.h[1];
    h[2] = BBox.h[2];	
    for (i = 0; i < 3; i++) {
		ref = d.x * BBox.axis[i].x + d.y * BBox.axis[i].y + d.z * BBox.axis[i].z;
		dist = ref;
		if (ref > h[i]) dist = h[i];
		if (ref < (- h[i])) dist = (- h[i]);

		// _ɍł߂BBox̓_XVD
        q_min += dist * BBox.axis[i];
	}

	// _q_minԃxNgD
    d = point - q_min;
	min_dist = sqrt(d.x * d.x + d.y * d.y + d.z * d.z) - radius;
	if (min_dist < 0.0f)
		min_dist = 0.0f;
    return(min_dist);
}

// _BBoxԂ̋̍őlD
float maxDistPointBBox(float4 point, float radius, BBox BBox)
// float4 point; _̍WlD
// float radius; ̔aD
// BBox BBox; ܃{bNXD
{
	int i;
    float h[3], ref, dist;
	float4 q_max, d;

	// l̐ݒD
    q_max = BBox.center;
    d = point - q_max;

	// BBox̊eӂɊÂċXVD
    h[0] = BBox.h[0];
    h[1] = BBox.h[1];
    h[2] = BBox.h[2];	
    for (i = 0; i < 3; i++) {
		ref = d.x * BBox.axis[i].x + d.y * BBox.axis[i].y + d.z * BBox.axis[i].z;
		if (ref >= 0.0f) dist = (- h[i]);
		if (ref < 0.0f) dist = h[i];

		// _łBBox̓_XVD
        q_max += dist * BBox.axis[i];
	}

	// _q_maxԃxNgD
    d = point - q_max;
	return(sqrt(d.x * d.x + d.y * d.y + d.z * d.z) + radius);
}

// BBoxm̊D̓O[oWnōsD
bool detectColBBoxes(float4 center0, float4 *axis0, float *h0, float4 center1, float4 *axis1, float *h1)
// float4 center0, float4 *axis0, float *h0; BBox0̒S_C3̎C3̑傫D
// float4 center1, float4 *axis1, float *h1; BBox1̒S_C3̎C3̑傫D
{
	unsigned int i;
	float4 inv_axis0[4], cc;

	// BBox1̍WBBox0̑̍WŒ`D
	transM(axis0, inv_axis0);
	for (i = 0; i < 3; i++) {
		axis1[i] = mulMV(inv_axis0, axis1[i]);
		axis1[i].w = 0.0f;
	}

	// BBox0BBox1̒S_BBox0̑̍WŒ`D
	center0 = mulMV(inv_axis0, center0);
	center1 = mulMV(inv_axis0, center1);

	// BBoxԂ̋6̕ɂĒׂD
	cc = center1 - center0;
	cc.w = 0.0f;
	if ((fabs(cc.x) > h0[X] + h1[X] * fabs(axis1[0].x) + h1[Y] * fabs(axis1[1].x) + h1[Z] * fabs(axis1[2].x))
	|| (fabs(cc.y) > h0[Y] + h1[X] * fabs(axis1[0].y) + h1[Y] * fabs(axis1[1].y) + h1[Z] * fabs(axis1[2].y))
	|| (fabs(cc.z) > h0[Z] + h1[X] * fabs(axis1[0].z) + h1[Y] * fabs(axis1[1].z) + h1[Z] * fabs(axis1[2].z))
	|| (fabs(dot(cc, axis1[0])) > h1[X] + h0[X] * fabs(axis1[0].x) + h0[Y] * fabs(axis1[0].y) + h0[Z] * fabs(axis1[0].z))
	|| (fabs(dot(cc, axis1[1])) > h1[Y] + h0[X] * fabs(axis1[1].x) + h0[Y] * fabs(axis1[1].y) + h0[Z] * fabs(axis1[1].z))
	|| (fabs(dot(cc, axis1[2])) > h1[Z] + h0[X] * fabs(axis1[2].x) + h0[Y] * fabs(axis1[2].y) + h0[Z] * fabs(axis1[2].z)))
		return(false);
	else
		return(true);
}

// BBox̕`D
void drawBBox(BBox BBox)
// BBox BBox; 
{
	float center[3], x[3], y[3], z[3];

	// BBox̒S_ƎRs[D
	center[X] = BBox.center.x; 
	center[Y] = BBox.center.y;
	center[Z] = BBox.center.z;
	x[X] = BBox.h[X] * BBox.axis[0].x;
	x[Y] = BBox.h[X] * BBox.axis[0].y;
	x[Z] = BBox.h[X] * BBox.axis[0].z;
	y[X] = BBox.h[Y] * BBox.axis[1].x;
	y[Y] = BBox.h[Y] * BBox.axis[1].y;
	y[Z] = BBox.h[Y] * BBox.axis[1].z;
	z[X] = BBox.h[Z] * BBox.axis[2].x;
	z[Y] = BBox.h[Z] * BBox.axis[2].y;
	z[Z] = BBox.h[Z] * BBox.axis[2].z;

	// BBox12{̕ӂŕ`D
	glBegin(GL_LINE_STRIP);
	glVertex3f(center[X] + (x[X] + y[X] + z[X]), 
			   center[Y] + (x[Y] + y[Y] + z[Y]),
			   center[Z] + (x[Z] + y[Z] + z[Z]));
	glVertex3f(center[X] + (- x[X] + y[X] + z[X]), 
			   center[Y] + (- x[Y] + y[Y] + z[Y]),
			   center[Z] + (- x[Z] + y[Z] + z[Z]));
	glVertex3f(center[X] + (- x[X] - y[X] + z[X]), 
			   center[Y] + (- x[Y] - y[Y] + z[Y]),
			   center[Z] + (- x[Z] - y[Z] + z[Z]));
	glVertex3f(center[X] + (x[X] - y[X] + z[X]), 
			   center[Y] + (x[Y] - y[Y] + z[Y]),
			   center[Z] + (x[Z] - y[Z] + z[Z]));
	glVertex3f(center[X] + (x[X] + y[X] + z[X]), 
			   center[Y] + (x[Y] + y[Y] + z[Y]),
			   center[Z] + (x[Z] + y[Z] + z[Z]));
	glEnd();
	glBegin(GL_LINE_STRIP);
	glVertex3f(center[X] + (x[X] + y[X] - z[X]), 
			   center[Y] + (x[Y] + y[Y] - z[Y]),
			   center[Z] + (x[Z] + y[Z] - z[Z]));
	glVertex3f(center[X] + (- x[X] + y[X] - z[X]), 
			   center[Y] + (- x[Y] + y[Y] - z[Y]),
			   center[Z] + (- x[Z] + y[Z] - z[Z]));
	glVertex3f(center[X] + (- x[X] - y[X] - z[X]), 
			   center[Y] + (- x[Y] - y[Y] - z[Y]),
			   center[Z] + (- x[Z] - y[Z] - z[Z]));
	glVertex3f(center[X] + (x[X] - y[X] - z[X]), 
			   center[Y] + (x[Y] - y[Y] - z[Y]),
			   center[Z] + (x[Z] - y[Z] - z[Z]));
	glVertex3f(center[X] + (x[X] + y[X] - z[X]), 
			   center[Y] + (x[Y] + y[Y] - z[Y]),
			   center[Z] + (x[Z] + y[Z] - z[Z]));
	glEnd();
	glBegin(GL_LINES);
	glVertex3f(center[X] + (x[X] + y[X] + z[X]), 
			   center[Y] + (x[Y] + y[Y] + z[Y]),
			   center[Z] + (x[Z] + y[Z] + z[Z]));
	glVertex3f(center[X] + (x[X] + y[X] - z[X]), 
			   center[Y] + (x[Y] + y[Y] - z[Y]),
			   center[Z] + (x[Z] + y[Z] - z[Z]));
	glVertex3f(center[X] + (- x[X] + y[X] + z[X]), 
			   center[Y] + (- x[Y] + y[Y] + z[Y]),
			   center[Z] + (- x[Z] + y[Z] + z[Z]));
	glVertex3f(center[X] + (- x[X] + y[X] - z[X]), 
			   center[Y] + (- x[Y] + y[Y] - z[Y]),
			   center[Z] + (- x[Z] + y[Z] - z[Z]));
	glVertex3f(center[X] + (- x[X] - y[X] + z[X]), 
			   center[Y] + (- x[Y] - y[Y] + z[Y]),
			   center[Z] + (- x[Z] - y[Z] + z[Z]));
	glVertex3f(center[X] + (- x[X] - y[X] - z[X]), 
			   center[Y] + (- x[Y] - y[Y] - z[Y]),
			   center[Z] + (- x[Z] - y[Z] - z[Z]));
	glVertex3f(center[X] + (x[X] - y[X] + z[X]), 
			   center[Y] + (x[Y] - y[Y] + z[Y]),
			   center[Z] + (x[Z] - y[Z] + z[Z]));
	glVertex3f(center[X] + (x[X] - y[X] - z[X]), 
			   center[Y] + (x[Y] - y[Y] - z[Y]),
			   center[Z] + (x[Z] - y[Z] - z[Z]));
	glEnd();
}

// BBox؂̓̐[BBoxQ̕`D
void drawBBoxes(int level, int draw_level, tree_node *node)
// int level; BBox؂̐[D
// int draw_level; `悵BBox̐[D
// tree_node *node; BBox؂̃m[hD
{

	// `悵[ɓBD
	if (draw_level == level) {
		drawBBox(node->BBox);
		return;
		
		// BOɖ[̃m[hɂȂĂ܂D
	} else if ((node->node0 == NULL) || (node->node1 == NULL))
		drawBBox(node->BBox);

	// ċAIɂɖ؂HD
	else {
		drawBBoxes(level + 1, draw_level, node->node0);
		drawBBoxes(level + 1, draw_level, node->node1);
	}
}

