#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "BasicDef.h"

// _Ƃ̌DꎞIȗpD
tmp_point *point_array[3 * MAX_NUM_TRIANGLES];
unsigned int num_tmp_points;

// _ɐڑӂ̃XgDꎞIȗpD
tmp_edge **connecting_edge;

// _D
double point[MAX_NUM_POINTS][3];
unsigned int num_points;

// ӁD
unsigned int edge[MAX_NUM_EDGES][2];
unsigned int num_edges;

// Op`|S̒_Ǝ͂̕ӁD
unsigned int triangle[MAX_NUM_TRIANGLES][3];
unsigned int triangle_edge[MAX_NUM_TRIANGLES][3];
unsigned int num_triangles;

// AXL[ŏꂽSTLt@C̓ǂݍ݁D
// ǂݍ܂ꂽẂCꎞIpoint_arrayɊi[D
bool readASCIISTLFile(const char* STL_file)
// const char* STL_File; STLt@C̖OD
{
	double x, y, z;
	char line[100];
	static char dummy[100];
	FILE *in;
	tmp_point *tmp_pnt;

	// STLt@C̃I[vD
	in = fopen(STL_file, "r");
	if (in == NULL)
		return false;

	// t@C̍W̓ǂݍ݁D
	printf("Trying text STL file ... ");
	num_tmp_points = 0;
	num_triangles = 0;
	while (fgets(line, 100, in) != NULL) {
		
		// vertex܂œǂݔ΂D
		if (strstr(line, "vertex") == NULL)
			continue;

		// A3_ǂݍ݃|So^D
		sscanf(line, "%s %lf %lf %lf", dummy, &x, &y, &z);
		tmp_pnt = (tmp_point *)malloc(sizeof(tmp_point));
		point_array[num_tmp_points] = tmp_pnt;
		tmp_pnt->coord[X] = x;
		tmp_pnt->coord[Y] = y;
		tmp_pnt->coord[Z] = z;
		tmp_pnt->index = num_tmp_points;
		num_tmp_points++;

		fgets(line, 100, in);
		sscanf(line, "%s %lf %lf %lf", dummy, &x, &y, &z);
		tmp_pnt = (tmp_point *)malloc(sizeof(tmp_point));
		point_array[num_tmp_points] = tmp_pnt;
		tmp_pnt->coord[X] = x;
		tmp_pnt->coord[Y] = y;
		tmp_pnt->coord[Z] = z;
		tmp_pnt->index = num_tmp_points;
		num_tmp_points++;

		fgets(line, 100, in);
		sscanf(line, "%s %lf %lf %lf", dummy, &x, &y, &z);
		tmp_pnt = (tmp_point *)malloc(sizeof(tmp_point));
		point_array[num_tmp_points] = tmp_pnt;
		tmp_pnt->coord[X] = x;
		tmp_pnt->coord[Y] = y;
		tmp_pnt->coord[Z] = z;
		tmp_pnt->index = num_tmp_points;
		num_tmp_points++;
		num_triangles++;
	}
	fclose(in);
	if (num_triangles > 0)
		printf("Done.\n");
	else
		printf("Failed.\n");
	return(num_triangles > 0);
}

// oCi[ŏꂽSTLt@C̓ǂݍ݁D
// ǂݍ܂ꂽẂCꎞIpoint_arrayɊi[D
bool readBinarySTLFile(const char* STL_file)
// const char* STL_File; STLt@C̖OD
{
	char line[85];
	FILE *in;
	float *coord;
	tmp_point *tmp_pnt;

	// STLt@C̃I[vD
	in = fopen(STL_file, "rb");
	if (in == NULL)
		return false;

	// ŏ84oCgǂݔ΂D
	if (fread(line, 1, 84, in) != 84) {
		return false;
	}
	printf("Trying binary STL file ... ");
	while (fread(line, 1, 50, in) == 50) {
		coord = (float *)line;
		
		// A3_ǂݍ݃|So^D
		tmp_pnt = (tmp_point *)malloc(sizeof(tmp_point));
		point_array[num_tmp_points] = tmp_pnt;
		tmp_pnt->coord[X] = coord[3];
		tmp_pnt->coord[Y] = coord[4];
		tmp_pnt->coord[Z] = coord[5];
		tmp_pnt->index = num_tmp_points;
		num_tmp_points++;

		tmp_pnt = (tmp_point *)malloc(sizeof(tmp_point));
		point_array[num_tmp_points] = tmp_pnt;
		tmp_pnt->coord[X] = coord[6];
		tmp_pnt->coord[Y] = coord[7];
		tmp_pnt->coord[Z] = coord[8];
		tmp_pnt->index = num_tmp_points;
		num_tmp_points++;

		tmp_pnt = (tmp_point *)malloc(sizeof(tmp_point));
		point_array[num_tmp_points] = tmp_pnt;
		tmp_pnt->coord[X] = coord[9];
		tmp_pnt->coord[Y] = coord[10];
		tmp_pnt->coord[Z] = coord[11];
		tmp_pnt->index = num_tmp_points;
		num_tmp_points++;
		num_triangles++;
	}
	fclose(in);
	if (num_triangles > 0)
		printf("Done.\n");
	else
		printf("Failed.\n");
	return(num_triangles > 0);
}

// _̔r֐D
int compare(tmp_point *point0, tmp_point *point1)
// tmp_point *point0, *point1; rΏۂ̓_D
{

	// XWlŔrD
	if (point0->coord[X] < (point1->coord[X] - (EPS)))
		return - 1;
	else if (point0->coord[X] > (point1->coord[X] + (EPS)))
		return 1;

	// YWlŔrD
	else {
		if (point0->coord[Y] < (point1->coord[Y] - (EPS)))
			return - 1;
		else if (point0->coord[Y] > (point1->coord[Y] + (EPS)))
			return 1;

		// ZWlŔrD
		else {
			if (point0->coord[Z] < (point1->coord[Z] - (EPS)))
				return - 1;
			else if (point0->coord[Z] > (point1->coord[Z] + (EPS)))
				return 1;
			else 
				return 0; // 2_͓ƌȂD
		}
	}
}

// _̃NCbN\[gD
void quickSort(int l, int r, tmp_point *point[])
// int l, r; \[g͈͂̍ƉẼCfbNXD
// tmp_point *point[]; \[gΏۂ̓_D
{
	int i, j;
	tmp_point *m_p, *swap;
	if (l < r) {
		m_p = point[(l + r) / 2];
		i = l - 1; 
		j = r + 1;
		while (true) {
			while (compare(point[++i], m_p) == - 1) {};
			while (compare(point[--j], m_p) == 1) {};
			if (i >= j) break;
			swap = point[i]; point[i] = point[j]; point[j] = swap;
		}
		quickSort(l, i - 1, point);
		quickSort(j + 1, r, point);
	}
}

// STLt@C̃[hD
bool loadSTLFile(const char* STL_file) 
// const char* STL_File; STLt@C̖OD
{
	unsigned int i, j, start, end;
	unsigned int tri_index, ver_index;	
	double ref_pnt[3] = {LARGE, LARGE, LARGE};
	tmp_edge *ed, *new_ed, *next_ed;

	// AXL[t@C̓ǂݍ݁DꎞIpoint_arrayɊi[D
	if (readASCIISTLFile(STL_file))
		printf("Triangles: %d ", num_triangles);

		// oCi[t@C̓ǂݍ݁DꎞIpoint_arrayɊi[D
	else if (readBinarySTLFile(STL_file))
		printf("Triangles: %d ", num_triangles);

		// ǂݍݎsD
	else {
		printf("Cannot open file.");
		return(false);
	}

	// ꂽ_Q\[gW̓_1ɂ܂Ƃ߂D
	quickSort(0, num_tmp_points - 1, point_array);

	// \[gς݂̓_擪XLD
	num_points = 0;
	for (i = 0; i <= num_tmp_points; i++) {

		// Ō̓_QƓ_Ƃ͈قȂ_D
		if ((i == num_tmp_points)
			|| (fabs(ref_pnt[X] - (point_array[i]->coord[X])) > (EPS)) 
			|| (fabs(ref_pnt[Y] - (point_array[i]->coord[Y])) > (EPS))
			|| (fabs(ref_pnt[Z] - (point_array[i]->coord[Z])) > (EPS))) {

			// W̓_Ă͂D𓯂_Ƃ
			// o^D
			end = i;
			if (i > 0) { // ŏD
				point[num_points][X] = ref_pnt[X];
				point[num_points][Y] = ref_pnt[Y];
				point[num_points][Z] = ref_pnt[Z];
				for (j = start; j < end; j++) {
					tri_index = point_array[j]->index / 3;
					ver_index = point_array[j]->index % 3;
					triangle[tri_index][ver_index] = num_points;
				}
				num_points++;
			}

			// KvȂQƓ_XVD
			if (end < num_tmp_points) {
				ref_pnt[X] = point_array[end]->coord[X];
				ref_pnt[Y] = point_array[end]->coord[Y];
				ref_pnt[Z] = point_array[end]->coord[Z];
				start = end;
			}
		}
	}

	// Ȍpoint_array͕svȂ̂ŃD
	for (i = 0; i < num_tmp_points; i++)
		free(point_array[i]);

	// Ōɕӂo^D
	num_edges = 0;
	
	// e_ɐڑӂ̋L^ꏊ̏D
	connecting_edge = (tmp_edge **)malloc(num_points * sizeof(tmp_edge));
	for (i = 0; i < num_points; i++)
		connecting_edge[i] = NULL;

	// eOp`̎͂̕ӂƓo^ς݂̕ӂrD
	for (i = 0; i < num_triangles; i++) {
		for (j = 0; j < 3; j++) {
			ed = connecting_edge[triangle[i][j]];
			while (ed != NULL) {

				// ɓo^ς݁D
				if (((ed->start == triangle[i][j]) && (ed->end == triangle[i][(j + 1) % 3]))
					|| ((ed->start == triangle[i][(j + 1) % 3]) && (ed->end == triangle[i][j])))
					goto try_next;
				ed = ed->next;
			}

			// o^̕ӂ̂ŐVɓo^D
			edge[num_edges][0] = triangle[i][j];
			edge[num_edges][1] = triangle[i][(j + 1) % 3];

			// ӂOp`ɂL^D
			triangle_edge[i][j] = num_edges;
			num_edges++;

			// ɓ_ɂo^ĂD
			new_ed = (tmp_edge *)malloc(sizeof(tmp_edge));
			new_ed->start = triangle[i][j];
			new_ed->end = triangle[i][(j + 1) % 3];
			new_ed->next = connecting_edge[triangle[i][j]];
			connecting_edge[triangle[i][j]] = new_ed;
			new_ed = (tmp_edge *)malloc(sizeof(tmp_edge));
			new_ed->start = triangle[i][(j + 1) % 3];
			new_ed->end = triangle[i][j];
			new_ed->next = connecting_edge[triangle[i][(j + 1) % 3]];
			connecting_edge[triangle[i][(j + 1) % 3]] = new_ed;
try_next:;
		}
	}

	// Ȍconnecting_edge͕svȂ̂ŃD
	for (i = 0; i < num_points; i++) {
		ed = connecting_edge[i];
		while (ed != NULL) {
			next_ed = ed->next;
			free(ed);
			ed = next_ed;
		}
	}
	free(connecting_edge);
	printf("Edges: %d ", num_edges);
	printf("Points: %d\n", num_points);
	return(true);
}
