#include "stdafx.h"
#include <gl/freeglut.h>
#include <math.h>

// EBhȄʒuƏTCYD
#define INIT_X_POS 128
#define INIT_Y_POS 128
#define INIT_WIDTH 512
#define INIT_HEIGHT 512

// EBhȄcTCYD
unsigned int window_width, window_height;

// 摜̕\͈́D
double left, right, bottom, top;

// WlQƂ̍ۂ̃CfbNXD
#define X 0
#define Y 1

// ~D
#define PI 3.141592653589793

// _D
#define MAX_NUM_POINTS 10000
double point[MAX_NUM_POINTS][2];
unsigned int num_points;

// \[hD
#define DISPLAY_POINTS 0
#define DISPLAY_CONES 1
unsigned int display_mode = DISPLAY_POINTS;

// 摜̍őTCYD摜̍ősNZ2048~1024ƉD
#define MAX_WIDTH 2048
#define MAX_HEIGHT 1024

// 摜̐Ff[^D
GLubyte color_data[MAX_WIDTH * MAX_HEIGHT][4];

// oꂽ_D
int detected_point_index = - 1;

// {mC_̐D
// [0, window_width]~[0, window_height]͈͓̔Ƀ_num̓_
// C_ƂD
void genPoints(unsigned int num)
// unsigned int num; _̌D
{
	double x, y;

	// numMAX_NUM_POINTS𒴂ꍇɂ́CȉɏCD
	if (num > MAX_NUM_POINTS) {
		printf("Too many points to generate.");
		num = MAX_NUM_POINTS;
	}

	// _̓EBhEŜɂ΂܂悤ɐD
	num_points = 0;
	while (true) {
		if (num_points >= num) {
			left = bottom = 0.0;
			right = (double)window_width;
			top = (double)window_height;
			return;
		}
		x = window_width * ((double)rand() / (double)RAND_MAX);
		y = window_height * ((double)rand() / (double)RAND_MAX);
		point[num_points][X] = x;
		point[num_points][Y] = y;
		num_points++;
	}
}

// {mC_̕\D
void displayPoints(void)
{
	unsigned int i;
	glPointSize(4.0f);
	glBegin(GL_POINTS);
	for (i = 0; i < num_points; i++) {
		if (i == detected_point_index)
			glColor3d(1.0, 1.0, 0.0); // o_̂ݐFςD
		else
			glColor3d(1.0, 0.0, 0.0);
		glVertex3d(point[i][X], point[i][Y], 0.0);
	}
	glEnd();
}

// {mC_ɔzuꂽ~`̕`D
void displayCone(double peak_point[])
// double peak_point[]; xyʏ̓_̍WD𒸓_Ƃ~xyʂ
//  ɕ`D
{
	int i;
	double x, y, radius;

	// EBhEɒS~EBhE𕢂s߂ɕKvȔaD
	radius = sqrt((double)(window_width * window_width + window_height * window_height)) * 1.1;

	// peak_point𒸓_Ƃ~`D
	glBegin(GL_TRIANGLE_FAN);
	glVertex3d(peak_point[X], peak_point[Y], 0.0);
	for (i = 0; i <= 360; i++) {
		x = radius * cos((i % 360) / 180.0 * PI);
		y = radius * sin((i % 360) / 180.0 * PI);
		glVertex3d(peak_point[X] + x, peak_point[Y] + y, (- radius));
	}
	glEnd();
}

// w肵IDɑΉF(r, g, b)^鏈D
void IDToColor(unsigned int id)
// unsigned int id; IDlD
{
	GLubyte r, g, b;
	unsigned int tmp;
	r = (GLubyte)(id / 65536); // 65536 = 256 * 256D
	tmp = id % 65536;
	g = (GLubyte)(tmp / 256);
	b = (GLubyte)(tmp % 256);
	glColor3ub(r, g, b);
}

// FΉID𓾂鏈D
unsigned int colorToID(GLubyte r, GLubyte g, GLubyte b)
// GLubyte r, g, b; Ff[^D
{
	return(r * 65536 + g * 256 + b);
}

// ~`Q̕\D
void displayCones(void)
{
	unsigned int i;
	for (i = 0; i < num_points; i++) {
		IDToColor(i);
		displayCone(point[i]);
	}
}

// \D
void display(void)
{
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(left, right, bottom, top, -1.0, 2000.0);
	glViewport(0, 0, window_width, window_height);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	switch (display_mode) {
		case DISPLAY_POINTS:
			displayPoints();
			break;
		case DISPLAY_CONES:
			displayCones();
			glReadPixels(0, 0, window_width, window_height, GL_RGBA, GL_UNSIGNED_BYTE, color_data);
			displayPoints();
			break;
		default:
			break;
	}
	glFlush();
}

// L[D
void keyboard(unsigned char key, int x, int y)
{
	switch (key) {
		case 'q':
		case 'Q':
		case '\033':
			exit(0);

			// _ȓ_Q̐D
		case 'g':
		case 'G':
			genPoints(1000);
			display_mode = DISPLAY_POINTS;
			glutPostRedisplay();
			break;
			
			// {mC}̐D
		case 'v':
		case 'V':
			display_mode = DISPLAY_CONES;
			glutPostRedisplay();
			break;
		default:
			break;
	}
}

// EBhETCY̕ύXD
void resize(int width, int height)
{
	unsigned int old_width, old_height;
	double d;

	// ݂̃EBhETCYmۂĂD
	old_width = window_width;
	old_height = window_height;

	// EBhETCYϐɂ܂D
	window_width = width;
	window_height = height;

	// EBhETCY̕ύXTCYɒuāC`͈͂␳D
	d = ((int)window_width - (int)old_width) * 0.5;
	right += d;
	left -= d;
	d = ((int)window_height - (int)old_height) * 0.5;
	top += d;
	bottom -= d;
}

// }EX̃{^D
void mouse_button(int button, int state, int x, int y)
{
	unsigned int shift, index;
	switch (button) {

		// }EX̍{^ƍŊ̓_擾D
		case GLUT_LEFT_BUTTON:
			if (state == GLUT_DOWN) {
				shift = window_width * (window_height - y) + x;
				index = colorToID(color_data[shift][0], color_data[shift][1], color_data[shift][2]);
				if (index < num_points) {
					detected_point_index = index;
					printf("Nearest point: %d\n", detected_point_index);
				}
				glutPostRedisplay();
				break;
			}
		default:
			break;
	}
}

// OpenGL֌W̏ݒD
void initGL(void)
{
	glClearColor(1.0f, 1.0f, 1.0f, 1.0f); // wiF͔D
	glEnable(GL_DEPTH_TEST); // fvXobt@@\gpD
	glClearDepth(1.0);
	glDepthFunc(GL_LESS);
	glDisable(GL_LIGHTING); // Ɩ͗pȂD
}

int main(int argc, char *argv[])
{
	glutInitWindowPosition(INIT_X_POS, INIT_Y_POS);
	glutInitWindowSize(INIT_WIDTH, INIT_HEIGHT);
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH);
	glutCreateWindow("Voronoi Diagram");
	glutDisplayFunc(display);
	glutKeyboardFunc(keyboard);
	glutReshapeFunc(resize);
	glutMouseFunc(mouse_button);
	initGL();
	glutMainLoop();
	return 0;
}

