#include <stdio.h>

#include <cuda_runtime.h>
#include <timer.h>

#define BLOCK 16 // eubN16~16̃Xbh`̂ƂD
#define WIDTH 1023 //1024 // Ώۂ̍s̃TCYWIDTH~WIDTHD

// zXgiCPUj̍s`D
float h_A[WIDTH * WIDTH];
float h_B[WIDTH * WIDTH];
float h_C[WIDTH * WIDTH];

// foCXiGPUj̍sւ̃|C^D
float *d_A, *d_B, *d_C;

void h_multiply(float *A, float *B, float *C);
__global__ void d_multiply0(float *A, float *B, float *C);
__global__ void d_multiply1(float *A, float *B, float *C);

// C֐D
int main()
{
	unsigned int i;

	// foCXɍsp̃mہD
    cudaMalloc((void**)&d_A, WIDTH * WIDTH * sizeof(float));
	cudaMalloc((void**)&d_B, WIDTH * WIDTH * sizeof(float));
	cudaMalloc((void**)&d_C, WIDTH * WIDTH * sizeof(float));

	// zXg̍sɒlZbgD
    for (i = 0; i < (WIDTH * WIDTH); i++) {
		h_A[i] = (float)i;
		h_B[i] = (float)i;
	}

    // vZԌvp̃^C}[̃ZbgD
	StartTimer();

	// zXg̍s̃f[^foCX̍s֓]D
	cudaMemcpy(d_A, h_A, WIDTH * WIDTH * sizeof(float), cudaMemcpyHostToDevice);
    cudaMemcpy(d_B, h_B, WIDTH * WIDTH * sizeof(float), cudaMemcpyHostToDevice);

	// ObhƃubN̒`D
    dim3 grid(WIDTH / BLOCK + 1, WIDTH / BLOCK + 1);
    dim3 block(BLOCK, BLOCK);

	// GPŰND
	d_multiply0 <<< grid, block >>> (d_A, d_B, d_C);
	//d_multiply1 <<< grid, block >>> (d_A, d_B, d_C);

	// vZʂd_CɊi[Ă̂ŁCzXgh_C֓]D
	cudaMemcpy(h_C, d_C, WIDTH * WIDTH * sizeof(float), cudaMemcpyDeviceToHost);

    // vZʂ̕\D
	printf("foCXvZ:   %f(ms)@", GetTimer());
	printf("foCXvZ: %f\n", h_C[WIDTH * WIDTH - 1]);

    // foCX̃D
	cudaFree(d_A);
	cudaFree(d_B);
	cudaFree(d_C);

	// rpɃzXgłvZĂ݂D
	StartTimer();
    h_multiply(h_A, h_B, h_C);
	printf("@zXgvZ: %f(ms)@", GetTimer());
	printf("@zXgvZ: %f\n", h_C[WIDTH * WIDTH - 1]);			
}

// CPUɂs̐ς̌vZD
void h_multiply(float *A, float *B, float *C)
{
	unsigned int r, c, i;
    float tmp;
	for (r = 0; r < WIDTH; r++) {
		for (c = 0; c < WIDTH; c++) {
	        tmp = 0.0;
	        for (i = 0; i < WIDTH; i++)
				tmp += A[WIDTH * r + i] * B[WIDTH * i + c];
	        C[WIDTH * r + c] = tmp;
		}
	}
}

// GPUɂs̐ς̌vZD
__global__ void d_multiply0(float *A, float *B, float *C)
{
	unsigned int r = blockDim.y * blockIdx.y + threadIdx.y;
	unsigned int c = blockDim.x * blockIdx.x + threadIdx.x;
    unsigned int i;
	float tmp;
	if ((r >= WIDTH) || (c >= WIDTH))
		return;
	tmp = 0.0f;
	for (i = 0; i < WIDTH; i++)
		tmp += A[WIDTH * r + i] * B[WIDTH * i + c];
	C[WIDTH * r + c] = tmp;
}

// GPUɂs̐ς̌vZD
// VFA[hgꍇD
__global__ void d_multiply1(float *A, float *B, float *C)
{
	unsigned int r = blockDim.y * blockIdx.y + threadIdx.y;
	unsigned int c = blockDim.x * blockIdx.x + threadIdx.x;
    unsigned int i, j;
	float tmp;
	__shared__ float s_A[BLOCK][BLOCK];
	__shared__ float s_B[BLOCK][BLOCK];
    tmp = 0.0f;
	for (i = 0; i < WIDTH; i += BLOCK) {

		// s̈ꕔVFA[hɊmہD
		s_A[threadIdx.y][threadIdx.x] = A[WIDTH * r + i + threadIdx.x];
		s_B[threadIdx.y][threadIdx.x] = B[WIDTH * (i + threadIdx.y) + c];
		__syncthreads();

        // VFA[hŐςvZD
		for (j = 0; j < BLOCK; j++)
			tmp += s_A[threadIdx.y][j] * s_B[j][threadIdx.x];
        __syncthreads();
	}
	C[WIDTH * r + c] = tmp;
}
