#include <stdio.h>
#include <gl/freeglut.h>
#include <math.h>

#include "BasicDef.h"

// _ݒɊւϐD
double eye[3];
double center[3] = {0.0, 0.0, 0.0};
double up[3];

// e̍WnD
double x_axis[3], y_axis[3], z_axis[3];

// EBhE̍WƃfW̕ϊɗpf[^D
double corner[3];
double pixel_size, ref_far, ref_near;

// ƖD
GLfloat light_pos[4];

// _D
extern double point[MAX_NUM_POINTS][3];
extern unsigned int num_points;

// Op`|SD
extern unsigned int triangle[MAX_NUM_TRIANGLES][3];
extern unsigned int num_triangles;

// {IȐ}`vZD
extern double dot(double vec0[], double vec1[]);
extern void cross(double vec0[], double vec1[], double vec2[]);
extern void normVec(double vec[]);
extern void normal(double p0[], double p1[], double p2[], double normal[]);

// ep̍s`DfEBhEtɕ\D
void defineViewMatrix(double phi, double theta, unsigned int width, unsigned int height, double margin)
// double phi, theta; ʊpƋp.
// unsigned int width, height; EBhẺ𑜓xD
// double margin; \ۂɗ̎͂ɗ^]TD
{
	unsigned int i, j;
	double c, s, xy_dist;
	double vec[3];
	double left, right, bottom, top, farVal, nearVal;
	double dx, dy, d_aspect, w_aspect, d;

	// _̐ݒD
	eye[Z] = sin(theta * PI / 180.0);
	xy_dist = cos(theta * PI / 180.0);
	c = cos(phi * PI / 180.0);
	s = sin(phi * PI / 180.0);
	eye[X] = xy_dist * c;
	eye[Y] = xy_dist * s;
	up[X] = - c * eye[Z];
	up[Y] = - s * eye[Z];
	up[Z] = s * eye[Y] + c * eye[X];
	normVec(up);

	// __ƂWn̒`D
	for (i = 0; i < 3; i++)
		z_axis[i] = eye[i] - center[i];
	normVec(z_axis);
	cross(up, z_axis, x_axis);
	normVec(x_axis);
	cross(z_axis, x_axis, y_axis);

	// left, right, bottom, top, nearVal, farVaľD
	left = bottom = farVal = LARGE;
	right = top = nearVal = - LARGE;
	for (i = 0; i < num_points; i++) {
		for (j = 0; j < 3; j++)
			vec[j] = point[i][j] - eye[j];		
		if (dot(x_axis, vec) < left)
			left = dot(x_axis, vec);
		if (dot(x_axis, vec) > right)
			right = dot(x_axis, vec);
		if (dot(y_axis, vec) < bottom)
			bottom = dot(y_axis, vec);
		if (dot(y_axis, vec) > top)
			top = dot(y_axis, vec);
		if (dot(z_axis, vec) < farVal)
			farVal = dot(z_axis, vec);
		if (dot(z_axis, vec) > nearVal)
			nearVal = dot(z_axis, vec);
	}

	// }`̎͂5%قǗ]T^D
	margin += (right - left) * 0.05;
	left -= margin;
	right += margin;
	bottom -= margin;
	top += margin;
	farVal -= margin;
	nearVal += margin;
	ref_far = farVal;
	ref_near = nearVal;

	// \͈͂̃AXyNgƃEBhẼAXyNg̔rD
	dx = right - left;
	dy = top - bottom;
	d_aspect = dy / dx;
	w_aspect = (double)height / (double)width;

	// EBhE\͈͂cD\͈͂cɍLD
	if (w_aspect > d_aspect) {
		d = (dy * (w_aspect / d_aspect - 1.0)) * 0.5;
		bottom -= d;
		top += d;

		// EBhE\͈͂D\͈͂ɍLD
	} else {
		d = (dx * (d_aspect / w_aspect - 1.0)) * 0.5;
		left -= d;
		right += d;
	}

	// esNZ̎TCYD
	pixel_size = (right - left) / width;

	// ̐ς̍̍WL^ĂD
	for (i = 0; i < 3; i++)
		corner[i] = eye[i] + bottom * y_axis[i] + left * x_axis[i] + farVal * z_axis[i];

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(left, right, bottom, top, - nearVal, - farVal);
	glViewport(0, 0, width, height);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(eye[X], eye[Y], eye[Z], center[X], center[Y], center[Z], up[X], up[Y], up[Z]); 
}

// f\֐D
void displayModel(void)
{
	unsigned int i;
	double nrml_vec[3];

	// ̐ݒD
	light_pos[0] = (float)eye[X];
	light_pos[1] = (float)eye[Y];
	light_pos[2] = (float)eye[Z];
	light_pos[3] = 0.0f;
	glLightfv(GL_LIGHT0, GL_POSITION, light_pos);

	// Ɩ̓_D
	glEnable(GL_LIGHTING);

	// `揈D
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glBegin(GL_TRIANGLES);
	for (i = 0; i < num_triangles; i++) {
		normal(point[triangle[i][0]], point[triangle[i][1]], point[triangle[i][2]], nrml_vec);
		if (dot(nrml_vec, z_axis) > 0.0)
			glNormal3dv(nrml_vec);
		else
			glNormal3d(- nrml_vec[X], - nrml_vec[Y], - nrml_vec[Z]);
		glVertex3dv(point[triangle[i][0]]);
		glVertex3dv(point[triangle[i][1]]);
		glVertex3dv(point[triangle[i][2]]);
	}
	glEnd();
	glFlush();
}

// sNZ̉Əc̔Ԓn(h, v)ƃfvXldCΉ郂fW𓾂D
void pixelCoordToModelCoord(int h, int v, float d, double point[])
// int h, v; sNZ̉Əc̔ԒnD
// float d; fvXlD
// double point[]; Ή郂fWD
{
	unsigned int i;

	// cornerɂ͍ɑΉ郂fWi[ĂD
	for (i = 0; i < 3; i++) {
		point[i] = corner[i] + pixel_size * h * x_axis[i] + pixel_size * v * y_axis[i]

			// fvXlnear0.0Cfar1.0ɑΉ悤ɐKĂD
			+ (ref_near - ref_far) * (1.0f - d) * z_axis[i];
	}
}

// fWΉEBhE̔Ԓn𓾂D
void modelCoordToPixelCoord(double point[], int *h_index, int *v_index)
// double point[]; fWD
// int *h_index, *v_index; ΉsNZ̔ԒnD
{
	double diff[3];
	diff[X] = point[X] - corner[X];
	diff[Y] = point[Y] - corner[Y];
	diff[Z] = point[Z] - corner[Z];
	*h_index = (int)floor(dot(diff, x_axis) / pixel_size);
	*v_index = (int)floor(dot(diff, y_axis) / pixel_size);
}
